%=======================================================================
%To solve optimization problem:
%Create a new subfolder in ...\PSG\MATLAB:
%..\PSG\MATLAB\problem_2
%Download and unpack the following zipped file from 'Data' to the created folder:
%'Mat_data_problem_2.zip'
%Run program 'problem_2.m'
%=======================================================================

clc;
clear;
addpath('..');

%Load data:
load('.\problem_2_data.mat')
%Define options for PSG solver:
stroptions.Precision = 9;
%Define input arguments:
string = {1.3571,'pm2_pen',-1.3571,'pm2_pen'};
w = {-10,-3};

%Solve optimization problems:
[xout, fval, status, output] = riskprog(string, w, H, [], [], d, [], [], Aeq, beq, lb, ub, [], stroptions);
 
%Display results:
disp(' ');
disp('Results: ');
%Display status of optimization problem:
disp(sprintf('status of optimization problem = %s', status));
%Display solving time:
disp(sprintf('solving time = %g', output.solving_time));
%Display objective:
disp(sprintf('objective = %g', fval));
%Display function:
disp(sprintf('pm2_pen= %g', output.frval(1)));
disp(sprintf('pm2_pen= %g', output.frval(2)));
%Display linear component of objective:
disp('linear component of objective:');
disp(output.fdval);
%Display left hand sides of linear equality:
disp(sprintf('linear equality = %g', output.fAeqval));
%Display residual of linear equality:
disp(sprintf('residual of linear equality = %g', output.rAeqval));
%Display optimal point:
disp('optimal point = ');
disp(xout');
